#include <stdio.h>
#include <stdlib.h>
#include <list>
#include <math.h>
#include <string.h>
#include "idl_export.h"
#include "idl_tools.h"

/*globals here*/
static char statusBuffer[256] ;

/* function protos */
extern IDL_VPTR IDL_CDECL array_any_match(int argc, IDL_VPTR argv[]);
//void IDL_CDECL zipExtract(int argc, IDL_VPTR argv[], char *argk);


/* define the functions */
static IDL_SYSFUN_DEF2 arrayUtils_functions[] = {
	{(IDL_FUN_RET)array_any_match, "ARRAY_ANY_MATCH",   2, 2, 0, 0},
};

//static IDL_SYSFUN_DEF2 arrayUtils_procedures[] = {
//	{(IDL_FUN_RET) zipCompress, "ZIPCOMPRESS", 2, 2, IDL_SYSFUN_DEF_F_KEYWORDS, 0},
//};

/* startup call when DLM is loaded */
int arrayUtils_startup(void)
{
        if (!IDL_SysRtnAdd(arrayUtils_functions, TRUE, ARRLEN(arrayUtils_functions))) 
		{
                return IDL_FALSE;
        }
        //if (!IDL_SysRtnAdd(IDLtoZipfile_procedures, FALSE, ARRLEN(IDLtoZipfile_procedures))) 
		//{
         //      return IDL_FALSE;
        //}

/*Register the exit handler*/
        IDL_ExitRegister(arrayUtils_exit_handler);
        return(IDL_TRUE);
}

/* called when IDL is shutdown */
void arrayUtils_exit_handler(void)
{

}

/*{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|*/

extern IDL_VPTR IDL_CDECL array_any_match(int argc, IDL_VPTR argv[])
{
	/*
     Called in IDL as 
	 success = array_any_match(array1, array2)
	 return a 1 if any element in the array is equal
	*/ 

	//both have to be arrays
	IDL_ENSURE_ARRAY(argv[0]);
	IDL_ENSURE_ARRAY(argv[1]);

	//have to be the same type
	if (argv[0]->type != argv[1]->type) {
		sprintf(statusBuffer, ("Arrays must be of the same type \n"));
		IDL_Message(IDL_M_NAMED_GENERIC, IDL_MSG_RET, statusBuffer);
        return IDL_GettmpLong(0);
	}

	int iCount0 = argv[0]->value.arr->n_elts;
	int iCount1 = argv[1]->value.arr->n_elts;

	if( iCount0 != iCount1){
		sprintf(statusBuffer, ("Arrays must be of the same length \n"));
		IDL_Message(IDL_M_NAMED_GENERIC, IDL_MSG_RET, statusBuffer);
        return IDL_GettmpLong(0);
	}
	long offset = 0;
    long currOffset = 0;


	switch(argv[1]->type) {
		case IDL_TYP_UNDEF:
			return IDL_GettmpLong(1);
			break;
		case IDL_TYP_OBJREF:
			{
			IDL_ULONG *pBuffer0 = (IDL_ULONG *)(argv[0]->value.arr->data);
			IDL_ULONG *pBuffer1 = (IDL_ULONG *) (argv[1]->value.arr->data);
			for( int i=0;i<iCount0;i++) if( pBuffer0[i] == pBuffer1[i] ) return IDL_GettmpLong(1);
			}
			break;
		case IDL_TYP_PTR:
			{
			IDL_ULONG *pBuffer0 = (IDL_ULONG *)(argv[0]->value.arr->data);
			IDL_ULONG *pBuffer1 = (IDL_ULONG *) (argv[1]->value.arr->data);
			for( int i=0;i<iCount0;i++) if( pBuffer0[i] == pBuffer1[i] ) return IDL_GettmpLong(1);
			}
			break;
		case IDL_TYP_BYTE:
			{
			UCHAR *pBuffer0 = (UCHAR *)(argv[0]->value.arr->data);
			UCHAR *pBuffer1 = (UCHAR *) (argv[1]->value.arr->data);
			for( int i=0;i<iCount0;i++) if( pBuffer0[i] == pBuffer1[i] ) return IDL_GettmpLong(1);
			}
			break;
		case IDL_TYP_INT:
			{
			IDL_INT *pBuffer0 = (IDL_INT *)(argv[0]->value.arr->data);
			IDL_INT *pBuffer1 = (IDL_INT *) (argv[1]->value.arr->data);
			for( int i=0;i<iCount0;i++) if( pBuffer0[i] == pBuffer1[i] ) return IDL_GettmpLong(1);
			}
			break;
		case IDL_TYP_UINT:
			{
			IDL_UINT *pBuffer0 = (IDL_UINT *)(argv[0]->value.arr->data);
			IDL_UINT *pBuffer1 = (IDL_UINT *) (argv[1]->value.arr->data);
			for( int i=0;i<iCount0;i++) if( pBuffer0[i] == pBuffer1[i] ) return IDL_GettmpLong(1);
			}
			break;
		case IDL_TYP_LONG:
			{
			IDL_LONG *pBuffer0 = (IDL_LONG *)(argv[0]->value.arr->data);
			IDL_LONG *pBuffer1 = (IDL_LONG *) (argv[1]->value.arr->data);
			for( int i=0;i<iCount0;i++) if( pBuffer0[i] == pBuffer1[i] ) return IDL_GettmpLong(1);
			}
			break;
		case IDL_TYP_ULONG:
			{
			IDL_ULONG *pBuffer0 = (IDL_ULONG *)(argv[0]->value.arr->data);
			IDL_ULONG *pBuffer1 = (IDL_ULONG *) (argv[1]->value.arr->data);
			for( int i=0;i<iCount0;i++) if( pBuffer0[i] == pBuffer1[i] ) return IDL_GettmpLong(1);
			}
			break;
		case IDL_TYP_FLOAT:
			{
			float *pBuffer0 = (float *)(argv[0]->value.arr->data);
			float *pBuffer1 = (float *) (argv[1]->value.arr->data);
			for( int i=0;i<iCount0;i++) if( pBuffer0[i] == pBuffer1[i] ) return IDL_GettmpLong(1);
			}
			break;
		case IDL_TYP_DOUBLE:
			{
			double *pBuffer0 = (double *)(argv[0]->value.arr->data);
			double *pBuffer1 = (double *) (argv[1]->value.arr->data);
			for( int i=0;i<iCount0;i++) if( pBuffer0[i] == pBuffer1[i] ) return IDL_GettmpLong(1);
			}
			break;
	}

  return IDL_GettmpLong(0);

}